pipeline {
    agent any
    stages {
        stage('test') {
            steps {
                script {
                    echo "Testing 1 the application..."
                    echo "Executing pipeline for branch $BRANCH_NAME"
                }
            }
        }
        stage('build') {
            when {
                expression{
                    BRANCH_NAME == 'master'
                }
            }
            steps {
                script {
                    echo "Building the application..."
                }
            }
        }
 
        stage('deploy') {
            when {
                expression{
                    BRANCH_NAME == 'master'
                }
            }
            steps {
                script {
                    def dockerCmd = 'sudo docker run -p 3080:3080 -d abaevalex/my-repo:1.3'
                    sshagent(['197f3f1a-b29a-404a-b575-8db1c971579d']) {
                        sh "ssh -o StrictHostKeyChecking=no ec2-user@3.145.73.214 ${dockerCmd}"
                    }
                }
            }
        }
    }
}
